.TH mmwrite G "May 2000" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
mmwrite - writes the sparse or dense matrix A to a Matrix Market (MM) formatted file.
.SH CALLING SEQUENCE
.nf
[err] = mmwrite(file,A,comm,typ,prec)
.fi
.SH PARAMETERS
.TP
file
: destination file
.TP
A
: sparse or full matrix
.TP
comm
: matrix of comments to prepend to the MM file. To build a comment matrix, use str2mat. For example:
.LP
  comment = str2mat(' Comment 1', ' Comment 2', ' and so on.')
.LP
  comm, uses the default: '';
.TP
typ
: type of the data: 'real', 'complex', 'integer', 'pattern'. If ommitted, the type 'real' is used.
.TP
prec
: number of digits to display for real or complex values. If ommitted, full working precision is used.
.TP
err
: error. If all operations are correctly passed, err = 0 

.SH DESCRIPTION
\fV[err] = mmwrite(file,A,comm,typ,prec)\fR writes the sparse or dense matrix A to a Matrix Market (MM) formatted file. The arguments: \fVcomm\fR, \fVtyp\fR, and \fVprec\fR, are optionnals. The \fVcomm\fR argument is used in order to add comments in the destination file, but theses comments can not be read by the routine mmread.
.LP
For the moment, this function only writes in the general format. No symmetries are used to reduce the matrix storage.
.LP
.SH EXAMPLE
.nf
A=makefish(4);
comm = str2mat(' Ceci', ' est une ', ' matrice test', '14/05/01');
[err] = mmwrite(file,A,comm)

.fi
.SH AUTHOR
Source given by the Matrix Market web site. Adaptations for Scilab done by Aladin team - 14 May 2001.
.SH SEE ALSO
mmread, mminfo