.TH jacobi G "March 2000" "Scilab Group" "Scilab Function"
.so ../sci.an
.SH NAME
jacobi - jacobi method
.SH CALLING SEQUENCE
.nf
[x,err,iter,flag,res]  = jacobi(A,b,x0,maxi,tol)
.fi
.SH PARAMETERS
.TP
A
: matrix of size n-by-n or function returning A*x
.TP
b
: right hand side vector
.TP
x0
: initial guess vector; \fVx0\fR uses the default, zeros(n,1)
.TP
maxi
: maximum number of iterations; \fVmaxi\fR uses the default, n
.TP
tol
: error tolerance; \fVtol\fR uses the default, 1000*%eps
.TP
x
: solution vector
.TP
err
: final residual norm
.TP
iter
: number of iterations performed
.TP
flag
: 0 = solution found to tolerance
.LP
  1 = no convergence given maxi
.TP
res
: residual vector
.SH DESCRIPTION
\fV[x,err,iter,flag,res]=jacobi(A,b,x0,maxi,tol)\fR solves the linear system \fVAx=b\fR using the Jacobi Method.
.SH EXAMPLE
.nf
A=makefish(4); b=rand(16,1);x0=zeros(16,1);
[x,err,iter,flag,res] = jacobi(A,b,x0)
max_it=16; tol=1000*%eps;
[x,err,iter,flag,res] = jacobi(A,b,x0,max_it,tol)

deff("y=matvec(x)","y=(A+eye(size(A,1),size(A,1)))*x");

[x,err,iter,flag,res] = jacobi(matvec,b,x0,max_it,tol)
[x,err,iter,flag,res] = jacobi(matvec,b,x0)
.fi
.SH AUTHOR
Source given by the Univ. of Tennessee and Oak Ridge National Laboratory. Adaptations for Scilab done by Aladin team - 20 March 2001.
.SH SEE ALSO
